--- pa_jack.c.dist	2004-12-23 18:30:09.000000000 +0000
+++ pa_jack.c	2005-07-26 20:25:46.000000000 +0100
@@ -573,7 +573,6 @@
             jack_port_t *p = jack_port_by_name( jackApi->jack_client, clientPorts[0] );
             curDevInfo->defaultLowInputLatency = curDevInfo->defaultHighInputLatency =
                 jack_port_get_latency( p ) / globalSampleRate;
-            free( p );
 
             for( i = 0; clientPorts[i] != NULL; i++)
             {
@@ -595,7 +594,6 @@
             jack_port_t *p = jack_port_by_name( jackApi->jack_client, clientPorts[0] );
             curDevInfo->defaultLowOutputLatency = curDevInfo->defaultHighOutputLatency =
                 jack_port_get_latency( p ) / globalSampleRate;
-            free( p );
 
             for( i = 0; clientPorts[i] != NULL; i++)
             {
@@ -634,7 +632,7 @@
     if( pthread_self() == mainThread_ )
     {
         assert( msg );
-        free( jackErr_ );
+        if ( jackErr_ ) free( jackErr_ );
         jackErr_ = malloc( strlen( msg ) );
         sprintf( jackErr_, msg );
     }
@@ -961,13 +959,11 @@
     {
         if( stream->local_input_ports[i] )
             ASSERT_CALL( jack_port_unregister( stream->jack_client, stream->local_input_ports[i] ), 0 );
-        free( stream->remote_output_ports[i] );
     }
     for( i = 0; i < stream->num_outgoing_connections; ++i )
     {
         if( stream->local_output_ports[i] )
             ASSERT_CALL( jack_port_unregister( stream->jack_client, stream->local_output_ports[i] ), 0 );
-        free( stream->remote_input_ports[i] );
     }
 
     if( terminateStreamRepresentation )
